import axios from "axios";
import ENVIRONMENTS from "../const/ENVIRONMENT";
export function createCart(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/generateCartForOrder/").concat(data.orderId);
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  return axios.get(url, {
    headers: headers
  });
}
export function updateCart(data) {
  console.log(data);
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/carts/").concat(data.cart.id);
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.put(url, data.cart, {
    headers: headers
  }).then(function (response) {
    console.log(response);
  }).catch(function (error) {
    console.log(error);
  });
}
export function getUserProfile(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/profiles/user.id:").concat(data.cart.user.id);
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  var resp = axios.get(url, {
    headers: headers
  }).then(function (response) {
    data.callback(response);
    return response;
  }).catch(function (error) {
    return error;
  });
  return resp;
} //create profile for new users

export function createProfile(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/profiles");
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.post(url, data, {
    headers: headers
  }).then(function (response) {
    console.log(response);
  }).catch(function (error) {
    console.log(error);
  });
}
export function updateUserProfile(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/profiles/user.id:").concat(data.cart.user.id);
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  var dataforprofile = {
    "user": data.cart.user,
    "billingContact": data.cart.billingContact,
    "shippingContact": data.cart.shippingContact
  };
  axios.put(url, dataforprofile, {
    headers: headers
  }).then(function (response) {
    data.callback(response);
  }).catch(function (error) {
    console.log(error);
  });
}
export function ValidatingAddress(data) {
  console.log(data.payload);
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/addressvalidation");
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.post(url, data.payload, {
    headers: headers
  }).then(function (response) {
    data.callback(response);
  }).catch(function (response) {
    console.log(response);
  });
}
export function getShippingMethods(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/carts/ ").concat(data.cart.id, " /shippingtypes");
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  return axios.post(url, data.cart, {
    headers: headers
  }).then(function (response) {
    data.callback(response);
  }).catch(function (response) {
    console.log(response);
  });
}
export function getTaxAmount(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/carts/ ").concat(data.cart.id, " /taxes");
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.post(url, data.cart, {
    headers: headers
  }).then(function (response) {
    data.callback(response);
    console.log(response);
  }).catch(function (error) {
    console.log(error);
  });
}
export function submitOrder(data, fn) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/carts/").concat(data.cart.id, "/order");
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.post(url, data.cart, {
    headers: headers
  }).then(function (response) {
    // handle success
    fn(response);
  }).catch(function (error) {
    fn(error);
  }).finally(function () {// always executed
  });
}
export function validateOrder(data) {
  var url = "".concat(ENVIRONMENTS.orchApi[data.env], "/v1/api/studentfulfillment/order/validate");
  var payload = {
    "orderId": data.orderId
  };
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.post(url, payload, {
    headers: headers
  }).then(function (response) {
    // handle success
    data.callback(true);
  }).catch(function (error) {
    data.callback(false);
  }).finally(function () {// always executed
  });
}
export function fulfillOrder(data) {
  var url = "".concat(ENVIRONMENTS.orchApi[data.env], "/v1/api/studentfulfillment/order/fulfill");
  var payload = {
    "orderId": data.orderId,
    "skipAddressForComboCode": "true",
    "callbackForSkipAddress": "NA"
  };
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.post(url, payload, {
    headers: headers
  }).then(function (response) {
    // handle success
    data.callback(true);
  }).catch(function (error) {
    data.callback(false);
  }).finally(function () {// always executed
  });
}
export function createPayPalTransaction(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/carts/createPayPalTransaction");
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  }; //  return axios.post(url, data.cart, {headers: headers});

  axios.post(url, data.cart, {
    headers: headers
  }).then(function (response) {
    // handle success
    data.callback(response);
  }).catch(function (error) {
    console.log(error);
  }).finally(function () {// always executed
  });
}
export function submitPayPalOrder(data) {
  var url = "".concat(ENVIRONMENTS.cartApi[data.env], "/v2/carts/addPayPalPaymentDetails");
  var headers = {
    'X-Authorization': data.userToken,
    'Content-Type': 'application/json'
  };
  axios.post(url, data.cart, {
    headers: headers
  }).then(function (response) {
    data.callback(response);
  }).catch(function (error) {
    console.log(error);
    data.callback(false);
  });
}