import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import React, { Component } from 'react';
import CartContainer from "../../Widgets/Cart/CartContainer";
import CartSummaryContainer from "../../Widgets/CartSummaryPricing/CartSummaryContainer";
import Title from "../../Widgets/Title/Title";
import '../../../Styles/font-awesome/scss/font-awesome.scss';
import './CartSummary.scss';
import { connect } from "react-redux";
import BillingAddress from "../../Widgets/Address/Biiling/Billing";
import ShippingMethods from "../../Widgets/ShippingMethods/ShippingMethods";
import PaymentOption from "../../Widgets/PaymentOptions/PaymentOption";
import CheckoutCartSummaryPricing from "../../Widgets/CheckoutCartSummaryPricing/CheckoutCartSummaryPricing";
import OrderConfirmationCardContainer from "../../Widgets/OrderConfirmation/OrderConfirmationContainer/OrderConfirmationContainer";

var CartSummary =
/*#__PURE__*/
function (_Component) {
  _inherits(CartSummary, _Component);

  function CartSummary() {
    _classCallCheck(this, CartSummary);

    return _possibleConstructorReturn(this, _getPrototypeOf(CartSummary).apply(this, arguments));
  }

  _createClass(CartSummary, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.callbacksHandler(this.props.successCallback, this.props.failureCallback, this.props.cancelCallback);
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(React.Fragment, null, React.createElement(Title, {
        title: "Shopping cart",
        backButton: true
      }), this.props.isCheckout === false && this.props.orderInfo.isOrderCompleted === false && React.createElement(React.Fragment, null, React.createElement("div", {
        className: "page-row"
      }, React.createElement(CartContainer, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env
      }), React.createElement(CartSummaryContainer, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env
      }))), React.createElement("div", {
        className: "container-topwrapper"
      }, this.props.isCheckout === true && this.props.isConfirmation === false && React.createElement(CheckoutCartSummaryPricing, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env,
        cart: this.props.cart,
        billingDetails: this.props.billingDetails,
        taxEstimate: this.props.taxEstimate
      }), this.props.isCheckout === true && this.props.isConfirmation === false && React.createElement(BillingAddress, {
        cart: this.props.cart,
        billingDetails: this.props.billingDetails,
        orderId: this.props.orderId,
        env: this.props.env,
        userToken: this.props.userToken
      })), this.props.isCheckout === true && this.props.isShippingMethodInfoShow === false && this.props.billingDetails !== null && React.createElement(ShippingMethods, {
        orderId: this.props.orderId,
        env: this.props.env,
        billingDetails: this.props.billingDetails,
        shippingDetails: this.props.shippingDetails,
        shipmethods: this.props.shipmethods,
        userToken: this.props.userToken
      }), this.props.isCheckout === true && this.props.isShippingMethodInfoShow === false && this.props.orderInfo.isOrderCompleted === false && this.props.isConfirmation === false && this.props.shippingType !== null && this.props.billingDetails !== null && this.props.taxEstimate !== null && React.createElement(PaymentOption, {
        env: this.props.env,
        userToken: this.props.userToken
      }), this.props.orderInfo.isOrderCompleted === true && this.props.isCheckout === false && React.createElement(OrderConfirmationCardContainer, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env,
        cart: this.props.cart,
        billingDetails: this.props.billingDetails,
        taxEstimate: this.props.taxEstimate
      }));
    }
  }]);

  return CartSummary;
}(Component);

function mapStateToProps(state) {
  return {
    isCheckout: state.cartActions.isCheckout,
    billingDetails: state.cartActions.billingDetails,
    shippingDetails: state.cartActions.shippingDetails,
    cart: state.cartActions.cart,
    shippingType: state.cartActions.shippingType,
    taxEstimate: state.cartActions.taxEstimate,
    isPaymentReady: state.cartActions.isPaymentReady,
    isPaymentCompleted: state.cartActions.isPaymentCompleted,
    orderInfo: state.cartActions.orderInfo,
    isConfirmation: state.cartActions.isConfirmation,
    isShippingMethodInfoShow: state.cartActions.isShippingMethodInfoShow
  };
}

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    callbacksHandler: function callbacksHandler(successCallback, failureCallback, cancelCallback) {
      dispatch({
        type: 'CALLBACKS_EXECUTED',
        data: {
          successCallback: successCallback,
          failureCallback: failureCallback,
          cancelCallback: cancelCallback
        }
      });
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(CartSummary);