export function validateFirstName(firstNameValue, errors) {
  if (firstNameValue === '') {
    errors["firstName"] = "Please fill in your first name";
  } else if (typeof firstNameValue !== "undefined") {
    if (!firstNameValue.match(/^[a-zA-Z ]{2,17}$/)) {
      errors["firstName"] = "Please enter a valid name, avoid numbers and special characters";
    } else {
      errors["firstName"] = "";
    }
  }
}
;
export function validateLastName(lastNameValue, errors) {
  if (lastNameValue === '') {
    errors["lastName"] = "Please fill in your last name";
  } else if (typeof lastNameValue !== "undefined") {
    if (!lastNameValue.match(/^[a-zA-Z ]{2,17}$/)) {
      errors["lastName"] = "Please enter a valid name, avoid numbers and special characters";
    } else {
      errors["lastName"] = "";
    }
  }
}
;
export function validateAddressLine1(addressValue, errors) {
  if (addressValue === '') {
    errors["addressLine1"] = "Please enter a valid street address";
  } else {
    errors["addressLine1"] = "";
  }
}
export function validateCity(city, errors) {
  if (city === '') {
    errors["city"] = "Please enter a valid city";
  } else if (typeof city !== "undefined") {
    if (!city.match(/^[a-zA-Z ]{2,30}$/)) {
      errors["city"] = "Please enter a valid city, avoid numbers and special characters";
    } else {
      errors["city"] = "";
    }
  }
}
export function validateState(state, errors) {
  if (state === '') {
    errors["stateOrProvince"] = "Please select a state";
  } else if (typeof state !== "undefined") {
    if (!state.match(/^[a-zA-Z ]{2,30}$/)) {
      errors["stateOrProvince"] = "Please select a state";
    } else {
      errors["stateOrProvince"] = "";
    }
  }
}
;
export function validateZipCA(zip, errors) {
  if (zip === '') {
    errors["postalCode"] = "Please enter a valid zip code";
  } else if (typeof zip !== "undefined") {
    if (!zip.match(/^[ABCEGHJKLMNPRSTVXY]{1}\d{1}[A-Z]{1} *\d{1}[A-Z]{1}\d{1}$/)) {
      errors["postalCode"] = "Please enter a valid zip code";
    } else {
      errors["postalCode"] = "";
    }
  }
}
export function validateZipUS(zip, errors) {
  if (zip === '') {
    errors["postalCode"] = "Please enter a valid zip code";
  } else if (typeof zip !== "undefined") {
    if (!zip.match(/^(\d{5}(-\d{4})?|[A-Z]\d[A-Z] *\d[A-Z]\d)$/)) {
      errors["postalCode"] = "Please enter a valid zip code";
    } else {
      errors["postalCode"] = "";
    }
  }
}
export function validateZipGB(zip, errors) {
  if (zip === '') {
    errors["postalCode"] = "Please enter a valid zip code";
  } else if (typeof zip !== "undefined") {
    if (!zip.match(/^[A-Z]{1,2}[0-9]{1,2}[A-Z]{0,1} ?[0-9][A-Z]{2}$/i)) {
      errors["postalCode"] = "Please enter a valid zip code";
    } else {
      errors["postalCode"] = "";
    }
  }
}
export function validatePhoneUS(phoneNumberValue, errors) {
  if (phoneNumberValue === '') {
    errors["phoneNumber"] = "Please fill in your phone number";
  } else if (typeof phoneNumberValue !== "undefined") {
    if (!phoneNumberValue.match(/^\(?\d\d\d\)?[,-] ?\d\d\d-?[,-]\d\d\d\d$/)) {
      errors["phoneNumber"] = "Phone number should contain only 10 numbers";
    } else {
      errors["phoneNumber"] = "";
    }
  }
}
;
export function validatePhoneCA(phoneNumberValue, errors) {
  if (phoneNumberValue === '') {
    errors["phoneNumber"] = "Please fill in your phone number";
  } else if (typeof phoneNumberValue !== "undefined") {
    if (!phoneNumberValue.match(/^\(?\d\d\d\)?[,-] ?\d\d\d-?[,-]\d\d\d\d$/)) {
      errors["phoneNumber"] = "Phone number should contain only 10 numbers";
    } else {
      errors["phoneNumber"] = "";
    }
  }
}
;
export function validatePhoneUK(phoneNumberValue, errors) {
  if (phoneNumberValue === '') {
    errors["phoneNumber"] = "Please fill in your phone number";
  } else if (typeof phoneNumberValue !== "undefined") {
    if (!phoneNumberValue.match(/^\(?\d\d\d\)?[,-] ?\d\d\d-?[,-]\d\d\d\d\d$/)) {
      errors["phoneNumber"] = "Phone number should contain only 11 numbers";
    } else {
      errors["phoneNumber"] = "";
    }
  }
}
;