import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import React, { Component } from "react";
import { connect } from "react-redux";
import US_States from "../../../../const/US_States";
import CA_States from "../../../../const/CA_States";
import { validateAddressLine1, validateCity, validateFirstName, validateLastName, validatePhoneUS, validatePhoneCA, validatePhoneUK, validateState, validateZipUS, validateZipCA, validateZipGB } from './AddressValidations';
import CheckoutAlert from "../../Alerts/CheckoutAlert";
import ShippingAddress from "../Shipping/Shipping";
import './Billing.scss';

var BillingAddress =
/*#__PURE__*/
function (_Component) {
  _inherits(BillingAddress, _Component);

  function BillingAddress(props) {
    var _this;

    _classCallCheck(this, BillingAddress);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BillingAddress).call(this, props));

    _this.editPhone = function (event) {
      var userSelection = "";

      if (window.getSelection) {
        userSelection = window.getSelection().toString();

        if (userSelection !== '') {
          var ele = event.target;
          var text = ele.value;
          text = text.slice(0, ele.selectionStart) + text.slice(ele.selectionEnd);
          ele.value = text;
        }
      }
    };

    _this.handlePhoneNumberUK = function (event) {
      if (event.target.name === "phoneNumber") {
        event.target.value = event.target.value.replace(/\D/g, "");

        if (event.target.value.length >= 3) {
          event.target.value = event.target.value.slice(0, 3) + "-" + event.target.value.slice(3, 6) + event.target.value.slice(6, 11);

          if (event.target.value.length >= 7) {
            event.target.value = event.target.value.slice(0, 7) + "-" + event.target.value.slice(7, 12);
          }
        }
      }
    };

    _this.handleChange = function (event) {
      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (event.target.name === 'phoneNumber') {
        _this.handlePhoneNumberUK(event);

        _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});
      }
    };

    _this.handleFirstNameValidation = function (event) {
      var errors = _this.state.errors;
      validateFirstName(event.target.value, errors);

      _this.setState({
        errors: errors
      }, function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.city !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        var inputFirstNameSaveCart = [];
        inputFirstNameSaveCart.push(_this.formatSaveCartRequest());
        inputFirstNameSaveCart[0].taxEstimate = _this.cartTaxAmount;
        inputFirstNameSaveCart[0].shippingType = _this.cartShippingTypes;
        _this.updatedCartwithFirstName = inputFirstNameSaveCart[0];

        _this.props.updateProfileDetails(_this.props.userToken, _this.props.env, _this.updatedCartwithFirstName, _this.props.orderId);

        _this.props.updateCartWithShipping(_this.props.userToken, _this.props.env, _this.updatedCartwithFirstName, _this.props.orderId);
      } else {
        console.log('address validating call invoking error - when triggering First Name');
      }
    };

    _this.handleLastNameValidation = function (event) {
      var errors = _this.state.errors;
      validateLastName(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.city !== '' && _this.state.firstName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        var inputLastNameSaveCart = [];
        inputLastNameSaveCart.push(_this.formatSaveCartRequest());
        inputLastNameSaveCart[0].taxEstimate = _this.cartTaxAmount;
        inputLastNameSaveCart[0].shippingType = _this.cartShippingTypes;
        _this.updatedCartwithLastName = inputLastNameSaveCart[0];

        _this.props.updateProfileDetails(_this.props.userToken, _this.props.env, _this.updatedCartwithLastName, _this.props.orderId);

        _this.props.updateCartWithShipping(_this.props.userToken, _this.props.env, _this.updatedCartwithLastName, _this.props.orderId);
      } else {
        console.log('address validating call invoking error - when triggering  Last Name');
      }
    };

    _this.handleAddressValidation = function (event) {
      var errors = _this.state.errors;
      validateAddressLine1(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.city !== '' && _this.state.lastName !== '' && _this.state.firstName !== '' && _this.state.phoneNumber !== '' && _this.state.addressLine1 !== '') {
        var inputStreetAddSaveCart = [];
        inputStreetAddSaveCart.push(_this.formatSaveCartRequest());
        inputStreetAddSaveCart[0].taxEstimate = _this.cartTaxAmount;
        inputStreetAddSaveCart[0].shippingType = _this.cartShippingTypes;
        _this.UpdatedCartWithStreetAdd = inputStreetAddSaveCart[0];

        _this.props.updateProfileDetails(_this.props.userToken, _this.props.env, _this.UpdatedCartWithStreetAdd, _this.props.orderId);

        _this.props.updateCartWithShipping(_this.props.userToken, _this.props.env, _this.UpdatedCartWithStreetAdd, _this.props.orderId);
      } else {
        console.log('address validating call invoking error - when triggering  street address');
      }
    };

    _this.handleCityValidation = function (event) {
      var errors = _this.state.errors;
      validateCity(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
          firstName: _this.state.firstName,
          lastName: _this.state.lastName,
          phoneNumber: _this.state.phoneNumber,
          address: {
            addressLine1: _this.state.addressLine1,
            city: _this.state.city,
            stateOrProvince: _this.state.stateOrProvince,
            postalCode: _this.state.postalCode,
            country: _this.countryOrigin,
            isoCountry: _this.props.cart.institution.country
          }
        }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
      } else {
        console.log('address validating call invoking error - when triggering city');
      }
    };

    _this.handleStateValidation = function (event) {
      var errors = _this.state.errors;
      validateState(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.city !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
          firstName: _this.state.firstName,
          lastName: _this.state.lastName,
          phoneNumber: _this.state.phoneNumber,
          address: {
            addressLine1: _this.state.addressLine1,
            city: _this.state.city,
            stateOrProvince: _this.state.stateOrProvince,
            postalCode: _this.state.postalCode,
            country: _this.countryOrigin,
            isoCountry: _this.props.cart.institution.country
          }
        }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
      } else {
        console.log('address validating call invoking error - when triggering  state or province');
      }
    };

    _this.handleZipValidation = function (event) {
      var errors = _this.state.errors;

      if (_this.props.cart.institution.country === "US") {
        validateZipUS(event.target.value, errors);
      } else if (_this.props.cart.institution.country === "GB") {
        validateZipGB(event.target.value, errors);
      } else if (_this.props.cart.institution.country === "CA") {
        validateZipCA(event.target.value, errors);
      }

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.city !== '' && _this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
          firstName: _this.state.firstName,
          lastName: _this.state.lastName,
          phoneNumber: _this.state.phoneNumber,
          address: {
            addressLine1: _this.state.addressLine1,
            city: _this.state.city,
            stateOrProvince: _this.state.stateOrProvince,
            postalCode: _this.state.postalCode,
            country: _this.countryOrigin,
            isoCountry: _this.props.cart.institution.country
          }
        }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
      } else {
        console.log('address validating call invoking error - when triggering  zip');
      }
    };

    _this.handlePhoneValidation = function (event) {
      var errors = _this.state.errors;

      if (_this.props.cart.institution.country === "US") {
        validatePhoneUS(event.target.value, errors);

        if (_this.state.city !== '' && _this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.postalCode !== '') {
          _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
            firstName: _this.state.firstName,
            lastName: _this.state.lastName,
            phoneNumber: _this.state.phoneNumber,
            address: {
              addressLine1: _this.state.addressLine1,
              city: _this.state.city,
              stateOrProvince: _this.state.stateOrProvince,
              postalCode: _this.state.postalCode,
              country: _this.countryOrigin,
              isoCountry: _this.props.cart.institution.country
            }
          }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
        } else {
          console.log('address validating call invoking error - when triggering  phone number');
        }
      } else if (_this.props.cart.institution.country === "GB") {
        validatePhoneUK(event.target.value, errors);

        if (_this.state.city !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.postalCode !== '') {
          _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
            firstName: _this.state.firstName,
            lastName: _this.state.lastName,
            phoneNumber: _this.state.phoneNumber,
            address: {
              addressLine1: _this.state.addressLine1,
              city: _this.state.city,
              stateOrProvince: _this.state.stateOrProvince,
              postalCode: _this.state.postalCode,
              country: _this.countryOrigin,
              isoCountry: _this.props.cart.institution.country
            }
          }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
        } else {
          console.log('address validating call invoking error - when triggering  phone number');
        }
      } else if (_this.props.cart.institution.country === "CA") {
        validatePhoneCA(event.target.value, errors);

        if (_this.state.city !== '' && _this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.postalCode !== '') {
          _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
            firstName: _this.state.firstName,
            lastName: _this.state.lastName,
            phoneNumber: _this.state.phoneNumber,
            address: {
              addressLine1: _this.state.addressLine1,
              city: _this.state.city,
              stateOrProvince: _this.state.stateOrProvince,
              postalCode: _this.state.postalCode,
              country: _this.countryOrigin,
              isoCountry: _this.props.cart.institution.country
            }
          }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
        } else {
          console.log('address validating call invoking error - when triggering  phone number');
        }
      }

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});
    };

    _this.handleexistinguserdetails = _this.handleexistinguserdetails.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleValidateAddressResponse = _this.handleValidateAddressResponse.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleShppingMethodResponse = _this.handleShppingMethodResponse.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleTaxMethodResponse = _this.handleTaxMethodResponse.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.state = {
      isSkipAlertShow: false,
      firstName: '',
      lastName: '',
      addressLine1: '',
      apartment: '',
      city: '',
      country: '',
      isoCountry: _this.props.cart.institution.country,
      stateOrProvince: '',
      phoneNumber: '',
      postalCode: '',
      selectedView: "UK",
      submitted: false,
      country_states: US_States,
      submitButtonClicked: false,
      errors: {},
      CartWithBilling: '',
      CartWithBillingAndShipping: '',
      shippingType: '',
      taxEstimate: '',
      nn: {},
      showComponent: false,
      cartTaxAmount: [],
      cartShippingTypes: [],
      countryOrigin: '',
      country_ex: ''
    };
    _this.showShippingAddress = _this.showShippingAddress.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(BillingAddress, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.cart.institution.country === "US") {
        this.countryOrigin = "United States";
      } else if (this.props.cart.institution.country === "GB") {
        this.countryOrigin = "United Kingdom";
      } else if (this.props.cart.institution.country === "CA") {
        this.countryOrigin = "Canada";
      }

      this.props.getProfileDetails(this.props.userToken, this.props.env, this.props.orderId, this.props.cart, this.handleexistinguserdetails);
    }
  }, {
    key: "handleexistinguserdetails",
    value: function handleexistinguserdetails(response) {
      console.log(response);
      this.setState({
        firstName: response.data.billingContact.firstName,
        lastName: response.data.billingContact.lastName,
        phoneNumber: response.data.billingContact.phoneNumber,
        addressLine1: response.data.billingContact.address.addressLine1,
        city: response.data.billingContact.address.city,
        stateOrProvince: response.data.billingContact.address.stateOrProvince,
        postalCode: response.data.billingContact.address.postalCode,
        country: response.data.billingContact.address.country,
        isoCountry: response.data.billingContact.address.isoCountry
      });

      if (this.countryOrigin === "United States") {
        this.country_ex = "US";
      } else if (this.countryOrigin === "United Kingdom") {
        this.country_ex = "GB";
      } else if (this.countryOrigin === "Canada") {
        this.country_ex = "CA";
      }

      this.props.ValidatingAddress(this.props.userToken, this.props.env, {
        firstName: response.data.billingContact.firstName,
        lastName: response.data.billingContact.lastName,
        phoneNumber: response.data.billingContact.phoneNumber,
        address: {
          addressLine1: response.data.billingContact.address.addressLine1,
          city: response.data.billingContact.address.city,
          stateOrProvince: response.data.billingContact.address.stateOrProvince,
          postalCode: response.data.billingContact.address.postalCode,
          country: response.data.billingContact.address.country,
          isoCountry: this.country_ex
        }
      }, this.props.cart, this.props.billingContact, this.props.orderId, this.handleValidateAddressResponse);
    }
  }, {
    key: "showShippingAddress",
    value: function showShippingAddress(e) {
      this.setState({
        showComponent: !!!e.target.checked
      });
      console.log(e.target.checked);
    }
  }, {
    key: "formatSaveCartRequest",
    value: function formatSaveCartRequest() {
      var updatedSaveCart = {};
      updatedSaveCart._links = this.props.cart._links;
      updatedSaveCart.institution = this.props.cart.institution;
      updatedSaveCart.saveCart = true;
      updatedSaveCart.remoteCartId = this.props.cart.remoteCartId;
      updatedSaveCart.subTotal = this.props.cart.subTotal;
      updatedSaveCart.id = this.props.cart.id;
      updatedSaveCart.user = this.props.cart.user;
      updatedSaveCart.items = this.props.cart.items;
      updatedSaveCart.orderId = this.props.orderId;
      updatedSaveCart.orderTotal = this.props.cart.subTotal;
      updatedSaveCart.billingContact = {
        "firstName": this.state.firstName,
        "lastName": this.state.lastName,
        "phoneNumber": this.state.phoneNumber,
        "address": {
          "addressLine1": this.state.addressLine1,
          "city": this.state.city,
          "country": this.countryOrigin,
          "stateOrProvince": this.state.stateOrProvince,
          "postalCode": this.state.postalCode,
          "isoCountry": this.props.cart.institution.country
        }
      };

      if (this.state.showComponent === false) {
        updatedSaveCart.shippingContact = {
          "firstName": this.state.firstName,
          "lastName": this.state.lastName,
          "phoneNumber": this.state.phoneNumber,
          "address": {
            "addressLine1": this.state.addressLine1,
            "city": this.state.city,
            "country": this.countryOrigin,
            "stateOrProvince": this.state.stateOrProvince,
            "postalCode": this.state.postalCode,
            "isoCountry": this.props.cart.institution.country
          }
        };
      }

      return updatedSaveCart;
    }
  }, {
    key: "handleValidateAddressResponse",
    value: function handleValidateAddressResponse(response) {
      console.log(this.state);

      if (response.data === true && this.state.firstName !== '' && this.state.lastName !== '' && this.state.phoneNumber !== '' && this.state.addressLine1 !== '' && this.state.city !== '') {
        this.setState({
          showAddressValidateAlert: false
        });
        var cart = [];
        cart.push(this.formatSaveCartRequest());
        this.CartWithBilling = cart[0];
        this.props.updateCartWithBilling(this.props.userToken, this.props.env, this.CartWithBilling, this.props.orderId);
        this.props.getShippingMethods(this.props.userToken, this.props.env, this.CartWithBilling, this.props.orderId, this.handleShppingMethodResponse);
        this.props.updateProfileDetails(this.props.userToken, this.props.env, this.CartWithBilling, this.props.orderId);
      } else {
        this.setState({
          showAddressValidateAlert: true
        });
        this.props.shippingMethodShowHandler();
      }
    }
  }, {
    key: "handleShppingMethodResponse",
    value: function handleShppingMethodResponse(response) {
      var UpdatedCartWithShpping = [];
      UpdatedCartWithShpping.push(this.formatSaveCartRequest());
      UpdatedCartWithShpping[0].shippingMethodTypes = response.data; // UpdatedCartWithShpping[0].shippingMethodTypes =   [
      //     {
      //         "displayText":"Ground",
      //         "shipperCode":"20",
      //         "shipperCharges":"0.00",
      //         "shipperType":"ShipperType",
      //         "description":"&lt;p&gt;If you submit your order now it will ship today.&lt;br/&gt;&lt;br/&gt;This date only applies to items that are currently in stock and do not require printing or assembly time. Please allow 1 business day for transit. (Remote areas and Alaska &amp; Hawaii may take longer.)&lt;/p&gt;"
      //     },
      //     {
      //         "displayText":"2nd Day (Flat Rate)",
      //         "shipperCode":"30",
      //         "shipperCharges":"6.00",
      //         "shipperType":"ShipperType",
      //         "description":"&lt;p&gt;If you submit your order now it will ship today.&lt;br/&gt;&lt;br/&gt;This date only applies to items that are currently in stock and do not require printing or assembly time. Please allow 1 business day for transit. (Remote areas and Alaska &amp; Hawaii may take longer.)&lt;/p&gt;"
      //     },
      //     {
      //         "displayText":"Overnight (Flat Rate)",
      //         "shipperCode":"40",
      //         "shipperCharges":"8.00",
      //         "shipperType":"ShipperType",
      //         "description":"&lt;p&gt;If you submit your order now it will ship today.&lt;br/&gt;&lt;br/&gt;This date only applies to items that are currently in stock and do not require printing or assembly time. Please allow 1 business day for transit. (Remote areas and Alaska &amp; Hawaii may take longer.)&lt;/p&gt;"
      //     }
      // ]

      this.props.shippingMethodsShowHandler(UpdatedCartWithShpping[0].shippingMethodTypes);
      console.log(UpdatedCartWithShpping[0]);

      if (response.data.length === 0) {
        UpdatedCartWithShpping[0].shippingType = {
          "displayText": "2nd Day (Flat Rate)",
          "shipperCode": "30",
          "shipperCharges": "6.00",
          "shipperType": "ShipperType",
          "description": "&lt;p&gt;If you submit your order now it will ship on 09/30/2019.&lt;br/&gt;&lt;br/&gt;This date only applies to items that are currently in stock and do not require printing or assembly time. Please allow 1 business day for transit. (Remote areas and Alaska &amp; Hawaii may take longer.)&lt;/p&gt;"
        };
        this.cartShippingTypes = UpdatedCartWithShpping[0].shippingType; //this.props.cart.push(this.props.billingDetails);

        this.CartWithBillingAndShipping = UpdatedCartWithShpping[0];
        this.props.updateCartWithShipping(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId);
        this.props.getTaxAmount(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId, this.handleTaxMethodResponse);
        return this.CartWithBillingAndShipping;
      } else {
        console.log('execute as a normal user with 0 shipping');
        UpdatedCartWithShpping[0].shippingType = response.data[0];
        this.cartShippingTypes = response.data[0]; //this.props.cart.push(this.props.billingDetails);

        this.CartWithBillingAndShipping = UpdatedCartWithShpping[0];
        this.props.updateCartWithShipping(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId);
        this.props.getTaxAmount(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId, this.handleTaxMethodResponse);
        return this.CartWithBillingAndShipping;
      }
    }
  }, {
    key: "handleTaxMethodResponse",
    value: function handleTaxMethodResponse(response) {
      console.log('getTaxAmount() invoking success');

      if (this.state.postalCode !== '' && this.state.city !== '' && this.state.lastName !== '' && this.state.addressLine1 !== '' && this.state.phoneNumber !== '' && this.state.firstName !== '') {
        var UpdatedCartWithTax = [];
        var tot = 0;
        UpdatedCartWithTax.push(this.CartWithBillingAndShipping);
        UpdatedCartWithTax[0].shipping = 0;
        UpdatedCartWithTax[0].taxEstimate = response.data;
        this.tot = UpdatedCartWithTax[0].taxEstimate + UpdatedCartWithTax[0].subTotal;
        UpdatedCartWithTax[0].orderTotal = this.tot;
        this.cartTaxAmount = UpdatedCartWithTax[0].taxEstimate;
        UpdatedCartWithTax[0].saveCart = true; // subTotal

        this.CartWithBillingAndShippingAndTax = UpdatedCartWithTax[0];
        this.props.updateCartWithShipping(this.props.userToken, this.props.env, this.CartWithBillingAndShippingAndTax, this.props.orderId);
        return this.CartWithBillingAndShippingAndTax;
      } else {
        console.log('address validating call invoking error');
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", {
        id: "address-component"
      }, React.createElement("div", {
        className: "address-container"
      }, React.createElement("div", {
        className: "sfc-col-8 checkout-step shipping-address"
      }, this.state.showAddressValidateAlert === true && React.createElement(CheckoutAlert, null), React.createElement("form", {
        className: "combo-code-form",
        id: "billingAddressForm",
        name: "billingAddressForm"
      }, React.createElement("h1", null, "Billing Address"), React.createElement("div", {
        className: "cc-row input-row"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left"
      }, React.createElement("div", {
        className: this.state.errors.firstName ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "firstName"
      }, "First name"), React.createElement("input", {
        type: "text",
        className: "cc-form-control",
        name: "firstName",
        onChange: this.handleChange,
        maxLength: 17,
        onBlur: this.handleFirstNameValidation,
        value: this.state.firstName
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.firstName))), React.createElement("div", {
        className: "cc-sm-6"
      }, React.createElement("div", {
        className: this.state.errors.lastName ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "lastName"
      }, "Last name"), React.createElement("input", {
        type: "text",
        className: "cc-form-control",
        name: "lastName",
        onBlur: this.handleLastNameValidation,
        onChange: this.handleChange,
        maxLength: 17,
        value: this.state.lastName
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.lastName)))), React.createElement("div", {
        className: "cc-row input-row"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left"
      }, React.createElement("div", {
        className: this.state.errors.addressLine1 ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "addressLine1"
      }, "Street address"), React.createElement("input", {
        type: "text",
        className: "cc-form-control addressLine1",
        name: "addressLine1",
        onBlur: this.handleAddressValidation,
        onChange: this.handleChange,
        maxLength: 35,
        value: this.state.addressLine1
      }), React.createElement("label", {
        className: "label-po-box"
      }, "We are unable to ship to P.O. boxes"), React.createElement("br", null), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.addressLine1))), React.createElement("div", {
        className: "cc-sm-6"
      }, React.createElement("div", null, React.createElement("label", {
        htmlFor: "apartment"
      }, "Apartment/Suite/Building (optional)"), React.createElement("input", {
        type: "text",
        className: "cc-form-control apartment",
        name: "apartment",
        onChange: this.handleChange,
        maxLength: 35,
        value: this.state.apartment
      })))), React.createElement("div", {
        className: "cc-row input-row country-state-zip"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left city"
      }, React.createElement("div", {
        className: this.state.errors.city ? "has-error" : undefined
      }, this.props.cart.institution.country === "US" || this.props.cart.institution.country === "CA" ? React.createElement("label", {
        htmlFor: "city"
      }, "City") : null, this.props.cart.institution.country === "GB" && React.createElement("label", {
        htmlFor: "city"
      }, "Town/City"), React.createElement("input", {
        type: "text",
        className: "cc-form-control",
        name: "city",
        onBlur: this.handleCityValidation,
        onChange: this.handleChange,
        maxLength: 40,
        value: this.state.city
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.city))), this.props.cart.institution.country === "US" || this.props.cart.institution.country === "CA" ? React.createElement("div", {
        className: "cc-md-3 cc-sm-3 state sfc-cc-state"
      }, React.createElement("div", {
        className: this.state.errors.stateOrProvince ? 'has-error' : undefined
      }, React.createElement("label", {
        htmlFor: "country"
      }, "State"), React.createElement("div", {
        className: "select-div"
      }, React.createElement("select", {
        className: "cc-form-control state",
        name: "stateOrProvince",
        onBlur: this.handleStateValidation,
        onChange: this.handleChange,
        value: this.state.stateOrProvince
      }, this.props.cart.institution.country === "US" && this.state.country_states["US"].map(function (country_states) {
        return React.createElement("option", {
          key: country_states
        }, " ", country_states);
      }), this.props.cart.institution.country === "CA" && CA_States.map(function (p) {
        return React.createElement("option", {
          key: p.id,
          value: p.sf
        }, "", p.states);
      })), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.stateOrProvince)))) : null, React.createElement("div", {
        className: "cc-md-3 cc-sm-3 zip"
      }, React.createElement("div", {
        className: this.state.errors.postalCode ? 'has-error' : undefined
      }, this.props.cart.institution.country === "US" || this.props.cart.institution.country === "GB" ? React.createElement("label", {
        htmlFor: "postalCode"
      }, " Zip code") : null, this.props.cart.institution.country === "CA" && React.createElement("label", {
        htmlFor: "postalCode"
      }, " Postal code"), this.props.cart.institution.country === "US" ? React.createElement("input", {
        type: "text",
        className: "cc-form-control zip-code",
        name: "postalCode",
        onBlur: this.handleZipValidation,
        onChange: this.handleChange,
        maxLength: 8,
        value: this.state.postalCode
      }) : null, this.props.cart.institution.country === "GB" && React.createElement("input", {
        type: "text",
        className: "cc-form-control zip-code",
        name: "postalCode",
        onBlur: this.handleZipValidation,
        onChange: this.handleChange,
        maxLength: 9,
        value: this.state.postalCode
      }), this.props.cart.institution.country === "CA" && React.createElement("input", {
        type: "text",
        className: "cc-form-control zip-code",
        name: "postalCode",
        onBlur: this.handleZipValidation,
        onChange: this.handleChange,
        maxLength: 8,
        value: this.state.postalCode
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.postalCode)))), React.createElement("div", {
        className: "cc-row input-row"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left sfc-cc-country"
      }, React.createElement("div", null, React.createElement("label", {
        htmlFor: "country"
      }, "Country"), React.createElement("input", {
        type: "country",
        className: "cc-form-control country",
        name: "country",
        value: this.countryOrigin,
        readOnly: true
      }))), React.createElement("div", {
        className: "cc-sm-6"
      }, React.createElement("div", {
        className: this.state.errors.phoneNumber ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "phoneNumber"
      }, "Phone number "), this.props.cart.institution.country === "US" && React.createElement("input", {
        type: "text",
        className: "cc-form-control phone",
        id: "phone-number",
        name: "phoneNumber",
        maxLength: "12",
        onBlur: this.handlePhoneValidation,
        onChange: this.handleChange,
        onKeyPress: this.handlePhoneNumber,
        onMouseUp: this.editPhone,
        onMouseDown: this.editPhone,
        value: this.state.phoneNumber
      }), this.props.cart.institution.country === "GB" && React.createElement("input", {
        type: "text",
        className: "cc-form-control phone",
        id: "phone-number",
        name: "phoneNumber",
        maxLength: "13",
        onBlur: this.handlePhoneValidation,
        onChange: this.handleChange,
        onKeyPress: this.handlePhoneNumberUK,
        onMouseUp: this.editPhone,
        onMouseDown: this.editPhone,
        value: this.state.phoneNumber
      }), this.props.cart.institution.country === "CA" && React.createElement("input", {
        type: "text",
        className: "cc-form-control phone",
        id: "phone-number",
        name: "phoneNumber",
        maxLength: "12",
        onBlur: this.handlePhoneValidation,
        onChange: this.handleChange,
        onKeyPress: this.handlePhoneNumber,
        onMouseUp: this.editPhone,
        onMouseDown: this.editPhone,
        value: this.state.phoneNumber
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.phoneNumber)))), React.createElement("div", {
        className: "cc-row"
      }, React.createElement("div", {
        className: "cc-lg-12"
      }, React.createElement("label", {
        className: "label-ground-ship",
        htmlFor: "address"
      }, "Ground shipping 3 - 6 days", React.createElement("br", null), "Remote areas, including Alaska and Hawaii, might take longer."))), React.createElement("h1", null, "Shipping Address"), React.createElement("label", {
        className: "checkbox-container ship-address"
      }, "Ship to billing address", React.createElement("input", {
        type: "checkbox",
        name: "enable_comment",
        value: "enable_comment",
        defaultChecked: true,
        onClick: this.showShippingAddress,
        tabIndex: "0"
      }), React.createElement("div", {
        role: "checkbox",
        className: "check-mark"
      })), this.state.showComponent ? React.createElement(ShippingAddress, {
        cart: this.props.cart,
        shippingDetails: this.props.shippingDetails,
        billingDetails: this.props.billingDetails,
        orderId: this.props.orderId,
        env: this.props.env,
        userToken: this.props.userToken
      }) : null))));
    }
  }]);

  return BillingAddress;
}(Component);

function mapStateToProps(state) {
  return {
    alerts: state.cartActions.alerts,
    billingContact: state.cartActions.billingContact,
    shippingContact: state.cartActions.shippingContact,
    shippingType: state.cartActions.shippingType,
    taxEstimate: state.cartActions.taxEstimate,
    shippingMethodTypes: state.cartActions.shippingMethodTypes
  };
}

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    ValidatingAddress: function ValidatingAddress(userToken, env, payload, cart, billingDetails, orderId, callback) {
      dispatch({
        type: 'BILLING_ADDRESS_VALIDATED',
        data: {
          userToken: userToken,
          env: env,
          payload: payload,
          callback: callback
        }
      });
    },
    createProfile: function createProfile(userToken, env, orderId, user) {
      dispatch({
        type: 'CREATE_PROFILE',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          user: user
        }
      });
    },
    updateCartWithBilling: function updateCartWithBilling(userToken, env, payload, billingDetails, orderId, callback) {
      dispatch({
        type: 'UPDATE_CART_DATA',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload,
          callback: callback
        }
      });
    },
    getProfileDetails: function getProfileDetails(userToken, env, orderId, payload, callback) {
      dispatch({
        type: 'CREAT_N_FETCH_PROFILE_DATA',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload,
          callback: callback
        }
      });
    },
    updateProfileDetails: function updateProfileDetails(userToken, env, payload, orderId) {
      dispatch({
        type: 'UPDATE_PROFILE_DETAILS',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload
        }
      });
    },
    getShippingMethods: function getShippingMethods(userToken, env, payload, orderId, callback) {
      dispatch({
        type: 'FETCH_SHIPPING_METHODS',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload,
          callback: callback
        }
      });
    },
    getTaxAmount: function getTaxAmount(userToken, env, payload, orderId, callback) {
      dispatch({
        type: 'FETCH_TAX_AMOUNT',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload,
          callback: callback
        }
      });
    },
    updateCartWithShipping: function updateCartWithShipping(userToken, env, cart, orderId, callback) {
      dispatch({
        type: 'UPDATE_CART_DATA',
        data: {
          userToken: userToken,
          env: env,
          cart: cart,
          orderId: orderId,
          callback: callback
        }
      });
    },
    shippingMethodShowHandler: function shippingMethodShowHandler() {
      dispatch({
        type: 'COMPONENT_SHIPPING_SHOW',
        data: true
      });
    },
    shippingMethodsShowHandler: function shippingMethodsShowHandler(smethods) {
      dispatch({
        type: 'ON_SHIPPING_METHODS_DATA',
        data: smethods
      });
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(BillingAddress);