import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import React, { Component } from "react";
import { connect } from "react-redux";
import US_States from "../../../../const/US_States";
import CA_States from "../../../../const/CA_States";
import { validateAddressLine1, validateCity, validateFirstName, validateLastName, validatePhoneUS, validatePhoneCA, validateState, validateZipUS, validateZipCA } from '../Biiling/AddressValidations';
import CheckoutAlert from "../../Alerts/CheckoutAlert";

var ShippingAddress =
/*#__PURE__*/
function (_Component) {
  _inherits(ShippingAddress, _Component);

  function ShippingAddress(props) {
    var _this;

    _classCallCheck(this, ShippingAddress);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ShippingAddress).call(this, props));

    _this.editPhone = function (event) {
      var userSelection = "";

      if (window.getSelection) {
        userSelection = window.getSelection().toString();

        if (userSelection !== '') {
          var ele = event.target;
          var text = ele.value;
          text = text.slice(0, ele.selectionStart) + text.slice(ele.selectionEnd);
          ele.value = text;
        }
      }
    };

    _this.handlePhoneNumber = function (event) {
      if (event.target.name === "phoneNumber") {
        event.target.value = event.target.value.replace(/\D/g, "");

        if (event.target.value.length >= 3) {
          event.target.value = event.target.value.slice(0, 3) + "-" + event.target.value.slice(3, 6) + event.target.value.slice(6, 10);

          if (event.target.value.length >= 7) {
            event.target.value = event.target.value.slice(0, 7) + "-" + event.target.value.slice(7, 11);
          }
        }
      }
    };

    _this.handleChange = function (event) {
      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (event.target.name === 'phoneNumber') {
        _this.handlePhoneNumber(event);

        _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});
      }
    };

    _this.handleFirstNameValidation = function (event) {
      var errors = _this.state.errors;
      validateFirstName(event.target.value, errors);

      _this.setState({
        errors: errors
      }, function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.city !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        var inputFirstNameSaveCart = [];
        inputFirstNameSaveCart.push(_this.formatSaveCartRequest());
        inputFirstNameSaveCart[0].taxEstimate = _this.items;
        inputFirstNameSaveCart[0].shippingType = _this.cartShippingTypes;
        _this.updatedCartwithFirstName = inputFirstNameSaveCart[0];

        _this.props.updateProfileDetails(_this.props.userToken, _this.props.env, _this.updatedCartwithFirstName, _this.props.orderId);

        _this.props.updateCartWithShipping(_this.props.userToken, _this.props.env, _this.updatedCartwithFirstName, _this.props.orderId);
      } else {
        console.log('address validating call invoking error - when triggering First Name');
      }
    };

    _this.handleLastNameValidation = function (event) {
      var errors = _this.state.errors;
      validateLastName(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.city !== '' && _this.state.firstName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        var inputLastNameSaveCart = [];
        inputLastNameSaveCart.push(_this.formatSaveCartRequest());
        inputLastNameSaveCart[0].taxEstimate = _this.cartTaxAmount;
        inputLastNameSaveCart[0].shippingType = _this.cartShippingTypes;
        _this.updatedCartwithLastName = inputLastNameSaveCart[0];

        _this.props.updateProfileDetails(_this.props.userToken, _this.props.env, _this.updatedCartwithLastName, _this.props.orderId);

        _this.props.updateCartWithShipping(_this.props.userToken, _this.props.env, _this.updatedCartwithLastName, _this.props.orderId);
      } else {
        console.log('address validating call invoking error - when triggering  Last Name');
      }
    };

    _this.handleAddressValidation = function (event) {
      var errors = _this.state.errors;
      validateAddressLine1(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.city !== '' && _this.state.lastName !== '' && _this.state.firstName !== '' && _this.state.phoneNumber !== '' && _this.state.addressLine1 !== '') {
        var inputStreetAddSaveCart = [];
        inputStreetAddSaveCart.push(_this.formatSaveCartRequest());
        inputStreetAddSaveCart[0].taxEstimate = _this.cartTaxAmount;
        inputStreetAddSaveCart[0].shippingType = _this.cartShippingTypes;
        _this.UpdatedCartWithStreetAdd = inputStreetAddSaveCart[0];

        _this.props.updateProfileDetails(_this.props.userToken, _this.props.env, _this.UpdatedCartWithStreetAdd, _this.props.orderId);

        _this.props.updateCartWithShipping(_this.props.userToken, _this.props.env, _this.UpdatedCartWithStreetAdd, _this.props.orderId);
      } else {
        console.log('address validating call invoking error - when triggering  street address');
      }
    };

    _this.handleCityValidation = function (event) {
      var errors = _this.state.errors;
      validateCity(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
          firstName: _this.state.firstName,
          lastName: _this.state.lastName,
          phoneNumber: _this.state.phoneNumber,
          address: {
            addressLine1: _this.state.addressLine1,
            city: _this.state.city,
            stateOrProvince: _this.state.stateOrProvince,
            postalCode: _this.state.postalCode,
            country: _this.countryOrigin,
            isoCountry: _this.props.cart.institution.country
          }
        }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
      } else {
        console.log('address validating call invoking error - when triggering city');
      }
    };

    _this.handleStateValidation = function (event) {
      var errors = _this.state.errors;
      validateState(event.target.value, errors);

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.city !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
          firstName: _this.state.firstName,
          lastName: _this.state.lastName,
          phoneNumber: _this.state.phoneNumber,
          address: {
            addressLine1: _this.state.addressLine1,
            city: _this.state.city,
            stateOrProvince: _this.state.stateOrProvince,
            postalCode: _this.state.postalCode,
            country: _this.countryOrigin,
            isoCountry: _this.props.cart.institution.country
          }
        }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
      } else {
        console.log('address validating call invoking error - when triggering  state or province');
      }
    };

    _this.handleZipValidation = function (event) {
      var errors = _this.state.errors;

      if (_this.props.cart.institution.country === "US") {
        validateZipUS(event.target.value, errors);
      } else if (_this.props.cart.institution.country === "GB") {
        validateZipCA(event.target.value, errors);
      }

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.city !== '' && _this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.phoneNumber !== '') {
        _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
          firstName: _this.state.firstName,
          lastName: _this.state.lastName,
          phoneNumber: _this.state.phoneNumber,
          address: {
            addressLine1: _this.state.addressLine1,
            city: _this.state.city,
            stateOrProvince: _this.state.stateOrProvince,
            postalCode: _this.state.postalCode,
            country: _this.countryOrigin,
            isoCountry: _this.props.cart.institution.country
          }
        }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
      } else {
        console.log('address validating call invoking error - when triggering  zip');
      }
    };

    _this.handlePhoneValidation = function (event) {
      var errors = _this.state.errors;

      if (_this.props.cart.institution.country === "US") {
        validatePhoneUS(event.target.value, errors);
      } else if (_this.props.cart.institution.country === "GB") {
        validatePhoneCA(event.target.value, errors);
      }

      _this.setState(_defineProperty({}, event.target.name, event.target.value), function () {});

      if (_this.state.city !== '' && _this.state.stateOrProvince !== '' && _this.state.postalCode !== '' && _this.state.firstName !== '' && _this.state.lastName !== '' && _this.state.addressLine1 !== '' && _this.state.postalCode !== '') {
        _this.props.ValidatingAddress(_this.props.userToken, _this.props.env, {
          firstName: _this.state.firstName,
          lastName: _this.state.lastName,
          phoneNumber: _this.state.phoneNumber,
          address: {
            addressLine1: _this.state.addressLine1,
            city: _this.state.city,
            stateOrProvince: _this.state.stateOrProvince,
            postalCode: _this.state.postalCode,
            country: _this.countryOrigin,
            isoCountry: _this.props.cart.institution.country
          }
        }, _this.props.cart, _this.props.billingContact, _this.props.orderId, _this.handleValidateAddressResponse);
      } else {
        console.log('address validating call invoking error - when triggering  phone number');
      }
    };

    _this.handleValidateAddressResponse = _this.handleValidateAddressResponse.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleShppingMethodResponse = _this.handleShppingMethodResponse.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleTaxMethodResponse = _this.handleTaxMethodResponse.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.state = {
      isSkipAlertShow: false,
      firstName: '',
      lastName: '',
      addressLine1: '',
      apartment: '',
      city: '',
      country: '',
      isoCountry: _this.props.cart.institution.country,
      stateOrProvince: '',
      phoneNumber: '',
      postalCode: '',
      selectedView: "UK",
      submitted: false,
      country_states: US_States,
      submitButtonClicked: false,
      errors: {},
      CartWithBilling: '',
      CartWithBillingAndShipping: '',
      shippingType: '',
      taxEstimate: '',
      showComponent: false,
      cartTaxAmount: [],
      cartShippingTypes: [],
      countryOrigin: ''
    };
    _this.showShippingAddress = _this.showShippingAddress.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(ShippingAddress, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.cart.institution.country === "US") {
        this.countryOrigin = "United States";
      } else if (this.props.cart.institution.country === "GB") {
        this.countryOrigin = "United Kingdom";
      } else if (this.props.cart.institution.country === "CA") {
        this.countryOrigin = "Canada";
      }
    }
  }, {
    key: "showShippingAddress",
    value: function showShippingAddress(e) {
      this.setState({
        showComponent: !!!e.target.checked
      });
      console.log(e.target.checked);
    }
  }, {
    key: "formatSaveCartRequest",
    value: function formatSaveCartRequest() {
      var updatedSaveCart = {};
      updatedSaveCart._links = this.props.cart._links;
      updatedSaveCart.institution = this.props.cart.institution;
      updatedSaveCart.saveCart = false;
      updatedSaveCart.remoteCartId = this.props.cart.remoteCartId;
      updatedSaveCart.subTotal = this.props.cart.subTotal;
      updatedSaveCart.id = this.props.cart.id;
      updatedSaveCart.user = this.props.cart.user;
      updatedSaveCart.items = this.props.cart.items;
      updatedSaveCart.billingContact = this.props.billingDetails;
      updatedSaveCart.shippingContact = {
        "firstName": this.state.firstName,
        "lastName": this.state.lastName,
        "phoneNumber": this.state.phoneNumber,
        "address": {
          "addressLine1": this.state.addressLine1,
          "city": this.state.city,
          "country": this.countryOrigin,
          "stateOrProvince": this.state.stateOrProvince,
          "postalCode": this.state.postalCode,
          "isoCountry": this.props.cart.institution.country
        }
      };
      return updatedSaveCart;
    }
  }, {
    key: "handleValidateAddressResponse",
    value: function handleValidateAddressResponse(response) {
      console.log(this.state);

      if (response.data === true && this.state.firstName !== '' && this.state.lastName !== '' && this.state.phoneNumber !== '' && this.state.addressLine1 !== '' && this.state.city !== '') {
        this.setState({
          showAddressValidateAlert: false
        });
        var cart = [];
        cart.push(this.formatSaveCartRequest());
        this.CartWithBilling = cart[0]; // this.cartWithShipping=  cart[0];

        this.props.updateCartWithBilling(this.props.userToken, this.props.env, this.CartWithBilling, this.props.orderId);
        this.props.getShippingMethods(this.props.userToken, this.props.env, this.CartWithBilling, this.props.orderId, this.handleShppingMethodResponse);
        this.props.updateProfileDetails(this.props.userToken, this.props.env, this.CartWithBilling, this.props.orderId);
      } else {
        this.setState({
          showAddressValidateAlert: true
        });
      }
    }
  }, {
    key: "handleShppingMethodResponse",
    value: function handleShppingMethodResponse(response) {
      var UpdatedCartWithShpping = [];
      UpdatedCartWithShpping.push(this.formatSaveCartRequest());

      if (response.data.length === 0) {
        UpdatedCartWithShpping[0].shippingType = {
          "displayText": "2nd Day (Flat Rate)",
          "shipperCode": "30",
          "shipperCharges": "6.00",
          "shipperType": "ShipperType",
          "description": "&lt;p&gt;If you submit your order now it will ship on 09/30/2019.&lt;br/&gt;&lt;br/&gt;This date only applies to items that are currently in stock and do not require printing or assembly time. Please allow 1 business day for transit. (Remote areas and Alaska &amp; Hawaii may take longer.)&lt;/p&gt;"
        };
        this.cartShippingTypes = UpdatedCartWithShpping[0].shippingType; //this.props.cart.push(this.props.billingDetails);

        this.CartWithBillingAndShipping = UpdatedCartWithShpping[0];
        this.props.updateCartWithShipping(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId);
        this.props.getTaxAmount(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId, this.handleTaxMethodResponse);
        return this.CartWithBillingAndShipping;
      } else {
        UpdatedCartWithShpping[0].shippingType = response.data[0];
        this.cartShippingTypes = response.data[0]; //this.props.cart.push(this.props.billingDetails);

        this.CartWithBillingAndShipping = UpdatedCartWithShpping[0];
        this.props.updateCartWithShipping(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId);
        this.props.getTaxAmount(this.props.userToken, this.props.env, this.CartWithBillingAndShipping, this.props.orderId, this.handleTaxMethodResponse);
        return this.CartWithBillingAndShipping;
      }
    }
  }, {
    key: "handleTaxMethodResponse",
    value: function handleTaxMethodResponse(response) {
      console.log('getTaxAmount() invoking success');

      if (this.state.stateOrProvince !== '' && this.state.postalCode !== '' && this.state.city !== '' && this.state.lastName !== '' && this.state.addressLine1 !== '' && this.state.phoneNumber !== '' && this.state.firstName !== '') {
        var UpdatedCartWithTax = [];
        UpdatedCartWithTax.push(this.CartWithBillingAndShipping);
        UpdatedCartWithTax[0].taxEstimate = response.data;
        this.cartTaxAmount = UpdatedCartWithTax[0].taxEstimate;
        this.CartWithBillingAndShippingAndTax = UpdatedCartWithTax[0];
        this.props.updateCartWithShipping(this.props.userToken, this.props.env, this.CartWithBillingAndShippingAndTax, this.props.orderId);
        return this.CartWithBillingAndShippingAndTax;
      } else {
        console.log('address validating call invoking error');
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", {
        id: "address-component"
      }, React.createElement("div", {
        className: "address-container"
      }, React.createElement("div", {
        className: "checkout-step shipping-address"
      }, this.state.showAddressValidateAlert === true && React.createElement(CheckoutAlert, null), React.createElement("form", {
        className: "combo-code-form",
        id: "ShippingAddressForm",
        name: "ShippingAddressForm"
      }, React.createElement("div", {
        className: "show_shipping"
      }, React.createElement("div", {
        className: "cc-row input-row"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left"
      }, React.createElement("div", {
        className: this.state.errors.firstName ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "firstName"
      }, "First name"), React.createElement("input", {
        type: "text",
        className: "cc-form-control",
        name: "firstName",
        onChange: this.handleChange,
        maxLength: 17,
        onBlur: this.handleFirstNameValidation,
        value: this.state.firstName
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.firstName))), React.createElement("div", {
        className: "cc-sm-6"
      }, React.createElement("div", {
        className: this.state.errors.lastName ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "lastName"
      }, "Last name"), React.createElement("input", {
        type: "text",
        className: "cc-form-control",
        name: "lastName",
        onBlur: this.handleLastNameValidation,
        onChange: this.handleChange,
        maxLength: 17,
        value: this.state.lastName
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.lastName)))), React.createElement("div", {
        className: "cc-row input-row"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left"
      }, React.createElement("div", {
        className: this.state.errors.addressLine1 ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "addressLine1"
      }, "Street address"), React.createElement("input", {
        type: "text",
        className: "cc-form-control addressLine1",
        name: "addressLine1",
        onBlur: this.handleAddressValidation,
        onChange: this.handleChange,
        maxLength: 35,
        value: this.state.addressLine1
      }), React.createElement("label", {
        className: "label-po-box"
      }, "We are unable to ship to P.O. boxes"), React.createElement("br", null), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.addressLine1))), React.createElement("div", {
        className: "cc-sm-6"
      }, React.createElement("div", null, React.createElement("label", {
        htmlFor: "apartment"
      }, "Apartment/Suite/Building (optional)"), React.createElement("input", {
        type: "text",
        className: "cc-form-control apartment",
        name: "apartment",
        onChange: this.handleChange,
        maxLength: 35,
        value: this.state.apartment
      })))), React.createElement("div", {
        className: "cc-row input-row country-state-zip"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left"
      }, React.createElement("div", {
        className: this.state.errors.city ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "city"
      }, "City"), React.createElement("input", {
        type: "text",
        className: "cc-form-control",
        name: "city",
        onBlur: this.handleCityValidation,
        onChange: this.handleChange,
        maxLength: 40,
        value: this.state.city
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.city))), this.props.cart.institution.country === "US" || this.props.cart.institution.country === "CA" ? React.createElement("div", {
        className: "cc-md-3 cc-sm-3 state sfc-cc-state"
      }, React.createElement("div", {
        className: this.state.errors.stateOrProvince ? 'has-error' : undefined
      }, React.createElement("label", {
        htmlFor: "country"
      }, "State"), React.createElement("div", {
        className: "select-div"
      }, React.createElement("select", {
        className: "cc-form-control state",
        name: "stateOrProvince",
        onBlur: this.handleStateValidation,
        onChange: this.handleChange,
        value: this.state.stateOrProvince
      }, this.props.cart.institution.country === "US" && this.state.country_states["US"].map(function (country_states) {
        return React.createElement("option", {
          key: country_states
        }, " ", country_states);
      }), this.props.cart.institution.country === "CA" && CA_States.map(function (p) {
        return React.createElement("option", {
          key: p.id,
          value: p.sf
        }, "", p.states);
      })), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.stateOrProvince)))) : null, React.createElement("div", {
        className: "cc-md-3 cc-sm-3 zip"
      }, React.createElement("div", {
        className: this.state.errors.postalCode ? 'has-error' : undefined
      }, this.props.cart.institution.country === "US" && React.createElement("label", {
        htmlFor: "postalCode"
      }, " Zip code"), this.props.cart.institution.country === "CA" && React.createElement("label", {
        htmlFor: "postalCode"
      }, " Postal code"), this.props.cart.institution.country === "US" && React.createElement("input", {
        type: "text",
        className: "cc-form-control zip-code",
        name: "postalCode",
        onBlur: this.handleZipValidation,
        onChange: this.handleChange,
        maxLength: 5,
        value: this.state.postalCode
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.postalCode), this.props.cart.institution.country === "CA" && React.createElement("input", {
        type: "text",
        className: "cc-form-control zip-code",
        name: "postalCode",
        onBlur: this.handleZipValidation,
        onChange: this.handleChange,
        maxLength: 7,
        value: this.state.postalCode
      })))), React.createElement("div", {
        className: "cc-row input-row"
      }, React.createElement("div", {
        className: "cc-sm-6 sfc-cc-left sfc-cc-country"
      }, React.createElement("div", null, React.createElement("label", {
        htmlFor: "country"
      }, "Country"), React.createElement("input", {
        type: "country",
        className: "cc-form-control country",
        name: "country",
        value: this.countryOrigin,
        readOnly: true
      }))), React.createElement("div", {
        className: "cc-sm-6"
      }, React.createElement("div", {
        className: this.state.errors.phoneNumber ? "has-error" : undefined
      }, React.createElement("label", {
        htmlFor: "phoneNumber"
      }, "Phone number "), React.createElement("input", {
        type: "text",
        className: "cc-form-control phone",
        id: "phone-number",
        name: "phoneNumber",
        maxLength: "12",
        onBlur: this.handlePhoneValidation,
        onChange: this.handleChange,
        onKeyPress: this.handlePhoneNumber,
        onMouseUp: this.editPhone,
        onMouseDown: this.editPhone,
        value: this.state.phoneNumber
      }), React.createElement("span", {
        className: "help-block"
      }, this.state.errors.phoneNumber)))), React.createElement("div", {
        className: "cc-row"
      }, React.createElement("div", {
        className: "cc-lg-12"
      }, React.createElement("label", {
        className: "label-ground-ship",
        htmlFor: "address"
      }, "Ground shipping 3 - 6 days", React.createElement("br", null), "Remote areas, including Alaska and Hawaii, might take longer."))))))));
    }
  }]);

  return ShippingAddress;
}(Component);

function mapStateToProps(state) {
  return {
    cart: state.cartActions.cart,
    alerts: state.cartActions.alerts,
    billingContact: state.cartActions.billingContact,
    shippingContact: state.cartActions.shippingContact
  };
}

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    ValidatingAddress: function ValidatingAddress(userToken, env, payload, cart, billingDetails, orderId, callback) {
      dispatch({
        type: 'BILLING_ADDRESS_VALIDATED',
        data: {
          userToken: userToken,
          env: env,
          payload: payload,
          callback: callback
        }
      });
    },
    createProfile: function createProfile(userToken, env, orderId, user) {
      dispatch({
        type: 'CREATE_PROFILE',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          user: user
        }
      });
    },
    updateCartWithBilling: function updateCartWithBilling(userToken, env, payload, billingDetails, orderId, callback) {
      dispatch({
        type: 'UPDATE_CART_DATA',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload,
          callback: callback
        }
      });
    },
    getProfileDetails: function getProfileDetails(userToken, env, orderId, payload) {
      dispatch({
        type: 'CREAT_N_FETCH_PROFILE_DATA',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload
        }
      });
    },
    updateProfileDetails: function updateProfileDetails(userToken, env, payload, orderId) {
      dispatch({
        type: 'UPDATE_PROFILE_DETAILS',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload
        }
      });
    },
    getShippingMethods: function getShippingMethods(userToken, env, payload, orderId, callback) {
      dispatch({
        type: 'FETCH_SHIPPING_METHODS',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload,
          callback: callback
        }
      });
    },
    getTaxAmount: function getTaxAmount(userToken, env, payload, orderId, callback) {
      dispatch({
        type: 'FETCH_TAX_AMOUNT',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          cart: payload,
          callback: callback
        }
      });
    },
    updateCartWithShipping: function updateCartWithShipping(userToken, env, cart, orderId, callback) {
      dispatch({
        type: 'UPDATE_CART_DATA',
        data: {
          userToken: userToken,
          env: env,
          cart: cart,
          orderId: orderId,
          callback: callback
        }
      });
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(ShippingAddress);