import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import React, { Component } from 'react';
import OrderConfirmationAlert from "../OrderConfirmationAlerts/OrderConfirmationAlert";
import { connect } from "react-redux";
import OrderItemSummary from "../OrderItemSummary/OrderItemSummary";
import OrderAmountSummary from "../OrderAmountSummary/OrderAmountSummary";
import OrderSummary from "../OrderSummary/OrderSummary";
import "./OrderConfirmationContainer.scss";

var OrderConfirmationCardContainer =
/*#__PURE__*/
function (_Component) {
  _inherits(OrderConfirmationCardContainer, _Component);

  function OrderConfirmationCardContainer() {
    _classCallCheck(this, OrderConfirmationCardContainer);

    return _possibleConstructorReturn(this, _getPrototypeOf(OrderConfirmationCardContainer).apply(this, arguments));
  }

  _createClass(OrderConfirmationCardContainer, [{
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: "container-fluid main-content order-confirmation-page"
      }, React.createElement(OrderConfirmationAlert, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env,
        cart: this.props.cart,
        billingDetails: this.props.billingDetails,
        shippingDetails: this.props.shippingDetails,
        taxEstimate: this.props.taxEstimate
      }), React.createElement("div", {
        className: "row order-confirmation"
      }, React.createElement("div", {
        className: "sfc-col-8 order-confirmation-list"
      }, React.createElement(OrderItemSummary, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env,
        cart: this.props.cart,
        billingDetails: this.props.billingDetails,
        shippingDetails: this.props.shippingDetails,
        taxEstimate: this.props.taxEstimate
      }), React.createElement("div", {
        className: "sfc-col-7"
      }, React.createElement(OrderAmountSummary, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env,
        cart: this.props.cart,
        billingDetails: this.props.billingDetails,
        shippingDetails: this.props.shippingDetails,
        taxEstimate: this.props.taxEstimate
      }))), React.createElement("div", {
        className: "sfc-col-3 order-summary-wrapper"
      }, React.createElement(OrderSummary, {
        userToken: this.props.userToken,
        orderId: this.props.orderId,
        env: this.props.env,
        cart: this.props.cart,
        billingDetails: this.props.billingDetails,
        shippingDetails: this.props.shippingDetails,
        taxEstimate: this.props.taxEstimate
      }))));
    }
  }]);

  return OrderConfirmationCardContainer;
}(Component);

function mapStateToProps(state) {
  return {
    isCheckout: state.cartActions.isCheckout,
    billingDetails: state.cartActions.billingDetails,
    shippingDetails: state.cartActions.shippingDetails,
    cart: state.cartActions.cart,
    shippingType: state.cartActions.shippingType,
    taxEstimate: state.cartActions.taxEstimate,
    isPaymentReady: state.cartActions.isPaymentReady,
    isPaymentCompleted: state.cartActions.isPaymentCompleted
  };
}

export default connect(mapStateToProps)(OrderConfirmationCardContainer);