import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import React, { Component } from "react";
import ReactDOM from 'react-dom';
import paypal from 'paypal-checkout';
import { connect } from "react-redux";
import { createPayPalTransaction } from "../../../api/cartApi";
import ENVIRONMENTS from "../../../const/ENVIRONMENT";
var PayPalButton = paypal.Button.driver('react', {
  React: React,
  ReactDOM: ReactDOM
});
var props;
var paymentId;

var PayPal =
/*#__PURE__*/
function (_Component) {
  _inherits(PayPal, _Component);

  _createClass(PayPal, [{
    key: "onAuthorize",
    value: function onAuthorize(data, actions) {
      var cart = Object.assign({}, props.cart);
      cart.paymentOption = "PayPal";
      cart.payerId = data.payerID;
      cart.paymentId = data.paymentID;
      cart.shippingContact = props.shippingContact;
      cart.billingContact = props.billingContact;
      cart.shippingType = props.shippingType;
      cart.taxEstimate = props.taxEstimate;
      var payLoad = {
        env: props.env,
        userToken: props.userToken,
        cart: cart
      };
      props.addPayPalPaymentDetails(props.userToken, props.env, cart, function (response) {
        if (response != false) {
          props.fulfillOrder(props.userToken, props.env, props.orderId, function (isValid) {
            if (isValid) {
              var orderInfo = {
                isOrderCompleted: true,
                orderNumber: response.data,
                errorCode: null
              };
              props.onOrderCompletion(orderInfo);
            } else {
              var _orderInfo = {
                isOrderCompleted: false,
                orderNumber: null,
                errorCode: "genericError"
              };
              props.onOrderCompletion(_orderInfo);
            }
          });
        }
      });
    }
  }, {
    key: "payment",
    value: function payment() {
      return paymentId;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      props = this.props;
      var data = {
        env: props.env,
        userToken: props.userToken,
        cart: props.cart
      };
      this.props.createPayPalTransaction(props.userToken, props.env, props.cart, function (response) {
        props.updatePaypalTransactionStatus(true);
        paymentId = response.data;
      });
    }
  }]);

  function PayPal(props) {
    var _this;

    _classCallCheck(this, PayPal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PayPal).call(this, props));
    _this.state = {
      paypalEnv: ENVIRONMENTS.paypalEnv[_this.props.env]
    };
    return _this;
  }

  _createClass(PayPal, [{
    key: "render",
    value: function render() {
      return React.createElement(React.Fragment, null, this.props.isPaymentIdGenerated && React.createElement(PayPalButton, {
        env: this.state.paypalEnv,
        payment: this.payment,
        commit: true // Optional: show a 'Pay Now' button in the checkout flow
        ,
        onAuthorize: this.onAuthorize
      }));
    }
  }]);

  return PayPal;
}(Component);

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    updatePaypalTransactionStatus: function updatePaypalTransactionStatus(response) {
      dispatch({
        type: 'UPDATE_PAYPAL_TRANSACTION_STATUS',
        data: response
      });
    },
    createPayPalTransaction: function createPayPalTransaction(userToken, env, payload, callback) {
      dispatch({
        type: 'FETCH_CREATE_PAYPAL_TRANSACTION',
        data: {
          userToken: userToken,
          env: env,
          cart: payload,
          callback: callback
        }
      });
    },
    addPayPalPaymentDetails: function addPayPalPaymentDetails(userToken, env, payload, callback) {
      dispatch({
        type: 'FETCH_AND_WATCH_PAYPAL',
        data: {
          userToken: userToken,
          env: env,
          cart: payload,
          callback: callback
        }
      });
    },
    onOrderCompletion: function onOrderCompletion(response) {
      dispatch({
        type: 'ON_ORDER_COMPLETION',
        data: response
      });
    },
    fulfillOrder: function fulfillOrder(userToken, env, payload, callback) {
      dispatch({
        type: 'FETCH_FULFILL_ORDER',
        data: {
          userToken: userToken,
          env: env,
          orderId: payload,
          callback: callback
        }
      });
    }
  };
};

function mapStateToProps(state) {
  return {
    cart: state.cartActions.cart,
    isPaymentIdGenerated: state.cartActions.isPaymentIdGenerated,
    shippingContact: state.cartActions.shippingDetails,
    billingContact: state.cartActions.billingDetails,
    shippingType: state.cartActions.shippingType,
    taxEstimate: state.cartActions.taxEstimate,
    orderId: state.cartActions.cart.orderId
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(PayPal);