import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import React, { Component } from "react";
import CreditCard from "../PaymentOptions/CreditCard";
import PayPal from "../PaymentOptions/PayPal";
import creditCardImg from "../../../Images/credit-card-img.png";
import payPalImg from "../../../Images/paypal-img.png";
import { connect } from "react-redux";

var PaymentOption =
/*#__PURE__*/
function (_Component) {
  _inherits(PaymentOption, _Component);

  function PaymentOption(props) {
    var _this;

    _classCallCheck(this, PaymentOption);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PaymentOption).call(this, props));

    _this.handleValidateOrder = function (isValid) {
      if (isValid) {
        if (_this.state.paymentType === "creditCard") {
          _this.setState({
            isCreditCardSelected: true,
            isPayPalSelected: false
          });
        } else if (_this.state.paymentType === "payPal") {
          _this.setState({
            isPayPalSelected: true,
            isCreditCardSelected: false
          });
        }
      } else {
        var orderInfo = {
          isOrderCompleted: false,
          orderNumber: null,
          errorCode: "genericError"
        };

        _this.props.onOrderCompletion(orderInfo);
      }
    };

    _this.handlePaymentOptionSelect = function (paymentType) {
      return function (event) {
        _this.setState({
          paymentType: paymentType
        });

        _this.props.validateOrder(_this.props.userToken, _this.props.env, _this.props.orderId, _this.handleValidateOrder);
      };
    };

    _this.handlePaymentOptionSelect = _this.handlePaymentOptionSelect.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleValidateOrder = _this.handleValidateOrder.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.state = {
      paymentType: null,
      isCreditCardSelected: false,
      isPayPalSelected: false
    };
    return _this;
  }

  _createClass(PaymentOption, [{
    key: "render",
    value: function render() {
      return React.createElement(React.Fragment, null, React.createElement("div", {
        className: "row checkout-page-row"
      }, React.createElement("div", {
        className: "sfc-col-8"
      }, React.createElement("h3", {
        className: "step-title payment"
      }, "Payment"), React.createElement("div", {
        className: "radio-container payment"
      }, React.createElement("ul", null, React.createElement("li", null, React.createElement("input", {
        type: "radio",
        id: "credit-card",
        name: "paymentRadio"
        /*onChange={this.radioChange}*/
        ,
        onClick: this.handlePaymentOptionSelect("creditCard")
      }), React.createElement("label", {
        className: "credit-card-label",
        htmlFor: "credit-card"
      }, React.createElement("img", {
        alt: "credit card",
        src: creditCardImg,
        width: "220px"
      })), React.createElement("div", {
        className: "check"
      })), React.createElement("li", null, React.createElement("input", {
        type: "radio",
        id: "payPal",
        name: "paymentRadio",
        value: "payPal"
        /*onChange={this.radioChange}*/
        ,
        onClick: this.handlePaymentOptionSelect("payPal")
      }), React.createElement("label", {
        className: "paypal-label",
        htmlFor: "payPal"
      }, React.createElement("img", {
        alt: "paypal",
        src: payPalImg,
        width: "54px"
      }), " "), React.createElement("div", {
        className: "check"
      })))), this.state.isCreditCardSelected === true && React.createElement(CreditCard, {
        env: this.props.env,
        userToken: this.props.userToken
      }), this.state.isPayPalSelected === true && React.createElement(PayPal, {
        env: this.props.env,
        userToken: this.props.userToken
      }))));
    }
  }]);

  return PaymentOption;
}(Component);

function mapStateToProps(state) {
  return {
    isCreditCardSelected: state.cartActions.isCreditCardSelected,
    isPayPalSelected: state.cartActions.isPayPalSelected,
    orderId: state.cartActions.cart.orderId
  };
}

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    validateOrder: function validateOrder(userToken, env, orderId, callback) {
      dispatch({
        type: 'FETCH_VALIDATE_ORDER',
        data: {
          userToken: userToken,
          env: env,
          orderId: orderId,
          callback: callback
        }
      });
    },
    onOrderCompletion: function onOrderCompletion(data) {
      dispatch({
        type: 'ON_ORDER_COMPLETION',
        data: data
      });
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(PaymentOption);