import { submitOrder } from "../api/cartApi";

var sjcl = require("./sjcl");

var cartData;
var callback;
var securityErrorAuthCodes = ["531", "811", "813"];
var cardErrorAuthCodes = ["201", "573", "605", "763", "767", "768", "903"];
var transactionErrorAuthCodes = ["269", "270", "271", "302", "303", "502", "503", "505", "508", "509", "510", "521", "522", "540", "541", "542", "543", "544", "547", "548", "549", "550", "570", "571", "595", "596", "719", "747", "754", "755", "756", "757", "758", "759", "760", "764", "765", "825", "834"];
var customAuthCodes = ["530"];
export function loadIframe(payload, fn) {
  callback = fn;
  cartData = JSON.parse(JSON.stringify(payload));
  var forms = "allow-forms ";
  var origin = "allow-same-origin ";
  var scripts = "allow-scripts ";
  var parseURL = cartData.iframeUrl;
  var sandboxVars = scripts + forms + origin;
  document.getElementById('aemCreditCardIframe').innerHTML = '<iframe id="paymentIframe" title="Credit Card Iframe" name="paymentIframe" sandbox="' + sandboxVars + '" scrolling ="no" style = "overflow: hidden; height: 105%; width: 100%;"></iframe>';
  document.getElementById('loadIframe').click();
  var arr = parseURL.split("/");
  var validOrigin = arr[0] + "//" + arr[2]; //https://secure-ppe.pearson.com

  startListener(validOrigin);
}
/*// Checks valid Origin vs Origin of the iFrame being
// loaded
function checkOrigin(origin) {

    if (origin == validOrigin) {

        setTimeout(function () {
            loadIframe();
            startListener(origin);
        }, 10);
    } else {
        console.log("Invalid Orgin");
    }
}*/
// If valid key received from expected origin
// initiate listener on Parent window

function startListener(origin) {
  new MessageReceiver({
    "validOrigin": origin
  }).start();
} // End listener on Cart


function stopListener(origin) {
  new MessageReceiver({
    "validOrigin": origin
  }).stop();
}

var MessageReceiver = function MessageReceiver(args) {
  args = args || {};
  var started = false;
  var validOrigin = args.validOrigin;
  var key = null;

  var defaultMsgProcessor = function defaultMsgProcessor(e) {
    if (typeof e.data == "string") {
      key = e.data;
    } else {
      console.log("key--" + key);
      decryptJSON(key, e);
    }
  };

  var msgProcessor = args.callback || defaultMsgProcessor;

  var processMessage = function processMessage(e) {
    if (validOrigin == "*" || validOrigin == e.origin) {
      msgProcessor(e);
    }
  };

  var startListening = function startListening(onStartCallback) {
    if (!started) {
      if (window.addEventListener) {
        window.addEventListener("message", processMessage, false);
      } else {
        /* attachEvent("onmessage",
             processMessage);*/
      }

      started = true;
      if (onStartCallback) onStartCallback();
    }
  };

  var stopListening = function stopListening(onStopCallback) {
    if (started) {
      if (window.removeEventListener) {
        window.removeEventListener("message", processMessage);
      } else {
        window.detachEvent("onmessage", processMessage);
      }

      started = false;
      if (onStopCallback) onStopCallback();
    }
  };

  return {
    "start": startListening,
    "stop": stopListening
  };
}; // Decrypt recevied JSON message from child window


function decryptJSON(key, e) {
  /* $('#aemCreditCardIframe').hide();
   document.getElementById("overlay").style.display = "block";
   $('#paymentProcessing').append(
       '<p>Payment Processing</p>');
  */
  //alert("decryptJSON");
  var encryptedCode = e.data.code;
  var encryptedMessage = e.data.message;
  var decryptedCode = sjcl.decrypt(key, e.data.code);
  var decryptedMessage = sjcl.decrypt(key, e.data.message);
  var decryptedAuthCode = null;

  if (typeof e.data.authCode != "undefined" && e.data.authCode != null) {
    decryptedAuthCode = sjcl.decrypt(key, e.data.authCode);
  }

  if (typeof e.data.orderId != "undefined" && e.data.orderId != null) {
    var encryptedOrderId = e.data.orderId;
    var decrptedOrderid = sjcl.decrypt(key, e.data.orderId);
    parseResponse(decryptedCode, decryptedMessage, decryptedAuthCode, decrptedOrderid);
  } else {
    parseResponse(decryptedCode, decryptedMessage, decryptedAuthCode);
    console.log("No Order Number generated");
  }
}

function parseResponse() {
  var code = arguments[0];
  var message = arguments[1];
  var authCode = arguments[2];
  var orderId = arguments[3];

  switch (code) {
    case "100":
      // $("#placeOrderBtn").prop("disabled", false);
      break;

    case "200":
      simulateRedirect(code, message, authCode, orderId);
      break;

    case "400":
      simulateRedirect(code, message, authCode, null);

    case "500":
      simulateRedirect(code, message, authCode, null);

    default:
      break;
  }
} // Redirect according to order response


function simulateRedirect() {
  var code = arguments[0];
  var message = arguments[1];
  var authCode = arguments[2];
  var orderId = arguments[3];
  cartData.cart.statusCode = code;
  cartData.cart.statusMessage = message;
  console.log("XXXXXXXXX" + code + "---" + message + "---" + authCode + "----" + orderId);

  if (code == "200" && orderId != null) {
    cartData.cart.orderNumber = orderId;

    if (cartData.cart.digitalOnly == true) {
      cartData.cart.orderNumber = "WEBE" + orderId;
    } else {
      cartData.cart.orderNumber = "WEB" + orderId;
    }

    submitOrder(cartData, function (response) {
      if (response.status == "200" || response.status == "202") {
        var orderDetails = {
          "orderNumber": cartData.cart.orderNumber,
          "isOrderCompleted": true,
          "errorCode": null
        };
      } else {
        var orderDetails = {
          "orderNumber": cartData.cart.orderNumber,
          "isOrderCompleted": true,
          "errorCode": "genericError"
        };
      }

      callback(orderDetails);
    });
  } else if (code == "500" || code == "400") {
    submitOrder(cartData, function (response) {
      if (response.status == "200" || response.status == "202") {
        var errorCode;

        if (securityErrorAuthCodes.includes(authCode)) {
          errorCode = "securityError";
        } else if (cardErrorAuthCodes.includes(authCode)) {
          errorCode = "cardError";
        } else if (transactionErrorAuthCodes.includes(authCode)) {
          errorCode = "transactionError";
        } else if (customAuthCodes.includes(authCode)) {
          errorCode = "custom";
        } else {
          errorCode = "genericError";
        }

        var orderDetails = {
          "orderNumber": null,
          "isOrderProcessed": true,
          "errorCode": errorCode
        };
      } else {
        var orderDetails = {
          "orderNumber": null,
          "isOrderProcessed": true,
          "errorCode": "genericError"
        };
      }

      callback(orderDetails);
    });
  }
}