import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import ACTION_TYPES from "./../../const/ACTION_TYPES";
var initialState = {
  cart: null,
  orderTotal: null,
  isCheckout: false,
  billingDetails: null,
  shippingDetails: null,
  taxEstimate: 0.00,
  shippingMethodTypes: null,
  shipmethods: null,
  shippingType: null,
  shipping: 0,
  orderDetails: false,
  isPaymentIdGenerated: false,
  isPaymentReady: false,
  isPaymentCompleted: false,
  isConfirmation: false,
  isShippingMethodInfoShow: false,
  orderInfo: {
    isOrderCompleted: false,
    orderNumber: null,
    errorCode: null
  },
  successCallback: null,
  failureCallback: null,
  cancelCallback: null,
  isPaymentMethodInfoShow: false
};
export default function cartReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case ACTION_TYPES.CART_ACTIONS.ON_CART_DATA:
      return Object.assign({}, state, _objectSpread({}, state, {
        cart: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.REMOVE_ITEM_FROM_CART_DATA:
      return Object.assign({}, state, _objectSpread({}, state, {
        cart: action.data,
        alerts: true
      }));

    case ACTION_TYPES.CART_ACTIONS.COMPONENT_SUMMARY_COMPLETED:
      return Object.assign({}, state, _objectSpread({}, state, {
        isCheckout: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.UPDATE_CART_DATA:
      return Object.assign({}, state, _objectSpread({}, state, {
        billingDetails: action.data.cart.billingContact,
        shippingType: action.data.cart.shippingType,
        taxEstimate: action.data.cart.taxEstimate,
        shippingMethodTypes: action.data.cart.shippingMethodTypes,
        shippingDetails: action.data.cart.shippingContact,
        isPaymentReady: true,
        isShippingMethodInfoShow: false,
        orderTotal: action.data.cart.subTotal + action.data.cart.taxEstimate + action.data.cart.shipping,
        shipping: action.data.cart.shipping
      }));

    case ACTION_TYPES.CART_ACTIONS.ON_ORDER_COMPLETION:
      return Object.assign({}, state, _objectSpread({}, state, {
        orderInfo: action.data,
        isCheckout: false
      }));

    case ACTION_TYPES.CART_ACTIONS.UPDATE_PAYPAL_TRANSACTION_STATUS:
      return Object.assign({}, state, _objectSpread({}, state, {
        isPaymentIdGenerated: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.ON_CREATE_PAYPAL_TRANSACTION:
      return Object.assign({}, state, _objectSpread({}, state, {
        isPaymentIdGenerated: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.FETCH_AND_WATCH_PAYPAL:
      return Object.assign({}, state, _objectSpread({}, state, {
        cartItems: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.COMPONENT_CHECKOUT_COMPLETED:
      return Object.assign({}, state, _objectSpread({}, state, {
        isConfirmation: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.COMPONENT_SHIPPING_SHOW:
      return Object.assign({}, state, _objectSpread({}, state, {
        isShippingMethodInfoShow: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.COMPONENT_PAYMENT_SHOW:
      return Object.assign({}, state, _objectSpread({}, state, {
        isPaymentMethodInfoShow: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.ON_SHIPPING_METHODS_DATA:
      return Object.assign({}, state, _objectSpread({}, state, {
        shipmethods: action.data
      }));

    case ACTION_TYPES.CART_ACTIONS.CALLBACKS_EXECUTED:
      return Object.assign({}, state, _objectSpread({}, state, {
        successCallback: action.data.successCallback,
        failureCallback: action.data.failureCallback,
        cancelCallback: action.data.cancelCallback
      }));

    default:
      return state;
  }
}