import _regeneratorRuntime from "@babel/runtime/regenerator";

var _marked =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchCreateCartData),
    _marked2 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchCreateCartData),
    _marked3 =
/*#__PURE__*/
_regeneratorRuntime.mark(updateCartData),
    _marked4 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchUpdateCartData),
    _marked5 =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchProfileData),
    _marked6 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchfetchProfileData),
    _marked7 =
/*#__PURE__*/
_regeneratorRuntime.mark(TriggervalidatingAddress),
    _marked8 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchTriggeringAddressValidate),
    _marked9 =
/*#__PURE__*/
_regeneratorRuntime.mark(createProfile),
    _marked10 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchcreateProfile),
    _marked11 =
/*#__PURE__*/
_regeneratorRuntime.mark(updateProfileData),
    _marked12 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchUpdateProfileData),
    _marked13 =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchShippingMethods),
    _marked14 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchFetchShippingMethods),
    _marked15 =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchTaxAmount),
    _marked16 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchFetchTaxAmount),
    _marked17 =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchValidateOrder),
    _marked18 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchValidateOrder),
    _marked19 =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchFulfillOrder),
    _marked20 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchFulfillOrder),
    _marked21 =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchSubmitPaypalOrder),
    _marked22 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchSubmitPaypalOrder),
    _marked23 =
/*#__PURE__*/
_regeneratorRuntime.mark(fetchCreatePaypalTransaction),
    _marked24 =
/*#__PURE__*/
_regeneratorRuntime.mark(watchCreatePaypalTransaction);

import { put, call, takeEvery } from "redux-saga/effects";
import ACTION_TYPES from "../const/ACTION_TYPES";
import * as CartApi from "../api/cartApi"; // cart summary page

export function fetchCreateCartData(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchCreateCartData$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.prev = 0;
          _context.next = 3;
          return call(CartApi.createCart, action.data);

        case 3:
          response = _context.sent;
          _context.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_CART_DATA,
            data: response.data
          });

        case 6:
          _context.next = 13;
          break;

        case 8:
          _context.prev = 8;
          _context.t0 = _context["catch"](0);
          console.error("Create Cart request failed");
          _context.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_CART_ERROR,
            error: _context.t0
          });

        case 13:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, null, [[0, 8]]);
}
export function watchCreateCartData() {
  return _regeneratorRuntime.wrap(function watchCreateCartData$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.CREAT_N_FETCH_CART_DATA, fetchCreateCartData);

        case 2:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2);
}
export function updateCartData(action) {
  var response;
  return _regeneratorRuntime.wrap(function updateCartData$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.prev = 0;
          _context3.next = 3;
          return call(CartApi.updateCart, action.data);

        case 3:
          response = _context3.sent;
          _context3.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_UPDATE_CART_DATA,
            data: response.data
          });

        case 6:
          _context3.next = 13;
          break;

        case 8:
          _context3.prev = 8;
          _context3.t0 = _context3["catch"](0);
          console.error("update Cart request failed");
          _context3.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.UPDATE_CART_DATA_ERROR,
            error: _context3.t0
          });

        case 13:
        case "end":
          return _context3.stop();
      }
    }
  }, _marked3, null, [[0, 8]]);
}
export function watchUpdateCartData() {
  return _regeneratorRuntime.wrap(function watchUpdateCartData$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          _context4.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.UPDATE_CART_DATA, updateCartData);

        case 2:
        case "end":
          return _context4.stop();
      }
    }
  }, _marked4);
}
export function fetchProfileData(action) {
  var response, response1;
  return _regeneratorRuntime.wrap(function fetchProfileData$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          _context5.prev = 0;
          _context5.next = 3;
          return call(CartApi.getUserProfile, action.data);

        case 3:
          response = _context5.sent;

          if (!(response.response.status === 500)) {
            _context5.next = 12;
            break;
          }

          _context5.next = 7;
          return call(CartApi.createProfile, {
            env: action.data.env,
            orderId: action.data.orderId,
            user: action.data.cart.user,
            userToken: action.data.userToken
          });

        case 7:
          response1 = _context5.sent;
          _context5.next = 10;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.CREATE_PROFILE_ON_LOAD,
            data: response1.data
          });

        case 10:
          _context5.next = 14;
          break;

        case 12:
          _context5.next = 14;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.PROFILE_DETAILS_ON_LOAD,
            data: response.data
          });

        case 14:
          _context5.next = 21;
          break;

        case 16:
          _context5.prev = 16;
          _context5.t0 = _context5["catch"](0);
          console.error("Profile details request failed");
          _context5.next = 21;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_CART_ERROR,
            error: _context5.t0
          });

        case 21:
        case "end":
          return _context5.stop();
      }
    }
  }, _marked5, null, [[0, 16]]);
}
export function watchfetchProfileData() {
  return _regeneratorRuntime.wrap(function watchfetchProfileData$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          _context6.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.CREAT_N_FETCH_PROFILE_DATA, fetchProfileData);

        case 2:
        case "end":
          return _context6.stop();
      }
    }
  }, _marked6);
} // checkout page

export function TriggervalidatingAddress(action) {
  var response;
  return _regeneratorRuntime.wrap(function TriggervalidatingAddress$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          _context7.prev = 0;
          _context7.next = 3;
          return call(CartApi.ValidatingAddress, action.data);

        case 3:
          response = _context7.sent;
          _context7.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.BILLING_ADDRESS_VALIDATED,
            data: response.data
          });

        case 6:
          _context7.next = 13;
          break;

        case 8:
          _context7.prev = 8;
          _context7.t0 = _context7["catch"](0);
          console.error("Address validate request failed");
          _context7.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.BILLING_ADDRESS_VALIDATED_ERROR,
            error: _context7.t0
          });

        case 13:
        case "end":
          return _context7.stop();
      }
    }
  }, _marked7, null, [[0, 8]]);
}
export function watchTriggeringAddressValidate() {
  return _regeneratorRuntime.wrap(function watchTriggeringAddressValidate$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          _context8.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.BILLING_ADDRESS_VALIDATED, TriggervalidatingAddress);

        case 2:
        case "end":
          return _context8.stop();
      }
    }
  }, _marked8);
}
export function createProfile(action) {
  var response;
  return _regeneratorRuntime.wrap(function createProfile$(_context9) {
    while (1) {
      switch (_context9.prev = _context9.next) {
        case 0:
          _context9.prev = 0;
          _context9.next = 3;
          return call(CartApi.createProfile, action.data);

        case 3:
          response = _context9.sent;
          _context9.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.CREATE_PROFILE_ON_LOAD,
            data: response.data
          });

        case 6:
          _context9.next = 13;
          break;

        case 8:
          _context9.prev = 8;
          _context9.t0 = _context9["catch"](0);
          console.error("CREATE Profile request failed");
          _context9.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.CREATE_PROFILE_ERROR,
            error: _context9.t0
          });

        case 13:
        case "end":
          return _context9.stop();
      }
    }
  }, _marked9, null, [[0, 8]]);
}
export function watchcreateProfile() {
  return _regeneratorRuntime.wrap(function watchcreateProfile$(_context10) {
    while (1) {
      switch (_context10.prev = _context10.next) {
        case 0:
          _context10.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.CREATE_PROFILE, createProfile);

        case 2:
        case "end":
          return _context10.stop();
      }
    }
  }, _marked10);
}
export function updateProfileData(action) {
  var response;
  return _regeneratorRuntime.wrap(function updateProfileData$(_context11) {
    while (1) {
      switch (_context11.prev = _context11.next) {
        case 0:
          _context11.prev = 0;
          _context11.next = 3;
          return call(CartApi.updateUserProfile, action.data);

        case 3:
          response = _context11.sent;
          _context11.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_UPDATE_PROFILE_DETAILS,
            data: response.data
          });

        case 6:
          _context11.next = 13;
          break;

        case 8:
          _context11.prev = 8;
          _context11.t0 = _context11["catch"](0);
          console.error("update Profile request failed");
          _context11.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.UPDATE_PROFILE_DETAILS_ERROR,
            error: _context11.t0
          });

        case 13:
        case "end":
          return _context11.stop();
      }
    }
  }, _marked11, null, [[0, 8]]);
}
export function watchUpdateProfileData() {
  return _regeneratorRuntime.wrap(function watchUpdateProfileData$(_context12) {
    while (1) {
      switch (_context12.prev = _context12.next) {
        case 0:
          _context12.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.UPDATE_PROFILE_DETAILS, updateProfileData);

        case 2:
        case "end":
          return _context12.stop();
      }
    }
  }, _marked12);
}
export function fetchShippingMethods(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchShippingMethods$(_context13) {
    while (1) {
      switch (_context13.prev = _context13.next) {
        case 0:
          _context13.prev = 0;
          _context13.next = 3;
          return call(CartApi.getShippingMethods, action.data);

        case 3:
          response = _context13.sent;
          _context13.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.GET_SHIPPING_METHODS_ON_LOAD,
            data: response.data
          });

        case 6:
          _context13.next = 13;
          break;

        case 8:
          _context13.prev = 8;
          _context13.t0 = _context13["catch"](0);
          console.error("shipping method request failed");
          _context13.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.GET_SHIPPING_METHODS_ON_LOAD_ERROR,
            error: _context13.t0
          });

        case 13:
        case "end":
          return _context13.stop();
      }
    }
  }, _marked13, null, [[0, 8]]);
}
export function watchFetchShippingMethods() {
  return _regeneratorRuntime.wrap(function watchFetchShippingMethods$(_context14) {
    while (1) {
      switch (_context14.prev = _context14.next) {
        case 0:
          _context14.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.FETCH_SHIPPING_METHODS, fetchShippingMethods);

        case 2:
        case "end":
          return _context14.stop();
      }
    }
  }, _marked14);
}
export function fetchTaxAmount(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchTaxAmount$(_context15) {
    while (1) {
      switch (_context15.prev = _context15.next) {
        case 0:
          _context15.prev = 0;
          _context15.next = 3;
          return call(CartApi.getTaxAmount, action.data);

        case 3:
          response = _context15.sent;
          _context15.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.GET_TAX_ON_LOAD,
            data: response.data
          });

        case 6:
          _context15.next = 13;
          break;

        case 8:
          _context15.prev = 8;
          _context15.t0 = _context15["catch"](0);
          console.error("Get Tax request failed");
          _context15.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.GET_TAX_ON_LOAD_ERROR,
            error: _context15.t0
          });

        case 13:
        case "end":
          return _context15.stop();
      }
    }
  }, _marked15, null, [[0, 8]]);
}
export function watchFetchTaxAmount() {
  return _regeneratorRuntime.wrap(function watchFetchTaxAmount$(_context16) {
    while (1) {
      switch (_context16.prev = _context16.next) {
        case 0:
          _context16.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.FETCH_TAX_AMOUNT, fetchTaxAmount);

        case 2:
        case "end":
          return _context16.stop();
      }
    }
  }, _marked16);
}
export function fetchValidateOrder(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchValidateOrder$(_context17) {
    while (1) {
      switch (_context17.prev = _context17.next) {
        case 0:
          _context17.prev = 0;
          _context17.next = 3;
          return call(CartApi.validateOrder, action.data);

        case 3:
          response = _context17.sent;
          _context17.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.VALIDATE_ORDER,
            data: response.data
          });

        case 6:
          _context17.next = 13;
          break;

        case 8:
          _context17.prev = 8;
          _context17.t0 = _context17["catch"](0);
          console.error("Validate order request failed");
          _context17.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.VALIDATE_ORDER_ERROR,
            error: _context17.t0
          });

        case 13:
        case "end":
          return _context17.stop();
      }
    }
  }, _marked17, null, [[0, 8]]);
}
export function watchValidateOrder() {
  return _regeneratorRuntime.wrap(function watchValidateOrder$(_context18) {
    while (1) {
      switch (_context18.prev = _context18.next) {
        case 0:
          _context18.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.FETCH_VALIDATE_ORDER, fetchValidateOrder);

        case 2:
        case "end":
          return _context18.stop();
      }
    }
  }, _marked18);
}
export function fetchFulfillOrder(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchFulfillOrder$(_context19) {
    while (1) {
      switch (_context19.prev = _context19.next) {
        case 0:
          _context19.prev = 0;
          _context19.next = 3;
          return call(CartApi.fulfillOrder, action.data);

        case 3:
          response = _context19.sent;
          _context19.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.FULFILL_ORDER,
            data: response.data
          });

        case 6:
          _context19.next = 13;
          break;

        case 8:
          _context19.prev = 8;
          _context19.t0 = _context19["catch"](0);
          console.error("Fulfill order request failed");
          _context19.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.FULFILL_ORDER_ERROR,
            error: _context19.t0
          });

        case 13:
        case "end":
          return _context19.stop();
      }
    }
  }, _marked19, null, [[0, 8]]);
}
export function watchFulfillOrder() {
  return _regeneratorRuntime.wrap(function watchFulfillOrder$(_context20) {
    while (1) {
      switch (_context20.prev = _context20.next) {
        case 0:
          _context20.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.FETCH_FULFILL_ORDER, fetchFulfillOrder);

        case 2:
        case "end":
          return _context20.stop();
      }
    }
  }, _marked20);
}
export function fetchSubmitPaypalOrder(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchSubmitPaypalOrder$(_context21) {
    while (1) {
      switch (_context21.prev = _context21.next) {
        case 0:
          _context21.prev = 0;
          _context21.next = 3;
          return call(CartApi.submitPayPalOrder, action.data);

        case 3:
          response = _context21.sent;
          _context21.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_SUBMIT_PAYPAL_ORDER,
            data: response.data
          });

        case 6:
          _context21.next = 13;
          break;

        case 8:
          _context21.prev = 8;
          _context21.t0 = _context21["catch"](0);
          console.error("Submit Paypal order failed");
          _context21.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.SUBMIT_PAYPAL_ORDER_ERROR,
            error: _context21.t0
          });

        case 13:
        case "end":
          return _context21.stop();
      }
    }
  }, _marked21, null, [[0, 8]]);
}
export function watchSubmitPaypalOrder() {
  return _regeneratorRuntime.wrap(function watchSubmitPaypalOrder$(_context22) {
    while (1) {
      switch (_context22.prev = _context22.next) {
        case 0:
          _context22.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.FETCH_AND_WATCH_PAYPAL, fetchSubmitPaypalOrder);

        case 2:
        case "end":
          return _context22.stop();
      }
    }
  }, _marked22);
}
export function fetchCreatePaypalTransaction(action) {
  var response;
  return _regeneratorRuntime.wrap(function fetchCreatePaypalTransaction$(_context23) {
    while (1) {
      switch (_context23.prev = _context23.next) {
        case 0:
          _context23.prev = 0;
          _context23.next = 3;
          return call(CartApi.createPayPalTransaction, action.data);

        case 3:
          response = _context23.sent;
          _context23.next = 6;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_CREATE_PAYPAL_TRANSACTION,
            data: response.data
          });

        case 6:
          _context23.next = 13;
          break;

        case 8:
          _context23.prev = 8;
          _context23.t0 = _context23["catch"](0);
          console.error("Create Paypal transaction failed");
          _context23.next = 13;
          return put({
            type: ACTION_TYPES.CART_ACTIONS.ON_CREATE_PAYPAL_TRANSACTION_ERROR,
            error: _context23.t0
          });

        case 13:
        case "end":
          return _context23.stop();
      }
    }
  }, _marked23, null, [[0, 8]]);
}
export function watchCreatePaypalTransaction() {
  return _regeneratorRuntime.wrap(function watchCreatePaypalTransaction$(_context24) {
    while (1) {
      switch (_context24.prev = _context24.next) {
        case 0:
          _context24.next = 2;
          return takeEvery(ACTION_TYPES.CART_ACTIONS.FETCH_CREATE_PAYPAL_TRANSACTION, fetchCreatePaypalTransaction);

        case 2:
        case "end":
          return _context24.stop();
      }
    }
  }, _marked24);
}